Loading...
Searching...
No Matches
BALL::VIEW::GLRenderer Class Reference
Visualisation » Renderer

`#include <BALL/VIEW/RENDERING/RENDERERS/glRenderer.h>`

Inheritance diagram for BALL::VIEW::GLRenderer:

## Classes

class | WrongModes

## Public Types

enum | RenderMode { RENDER_MODE_UNDEFINED = 0 , RENDER_MODE_SOLID , RENDER_MODE_TRANSPARENT , RENDER_MODE_ALWAYS_FRONT }
enum | BufferMode { DIRECT_RENDERING = 0 , DISPLAY_LISTS_RENDERING , REBUILD_DISPLAY_LISTS }
typedef unsigned int | Name
| Typedef for OPENGL names.
Public Types inherited from BALL::VIEW::Renderer
enum | StereoMode { NO_STEREO = 0 , ACTIVE_STEREO , DUAL_VIEW_STEREO , DUAL_VIEW_DIFFERENT_DISPLAY_STEREO , TOP_BOTTOM_STEREO , INTERLACED_STEREO }

## Public Member Functions

| GLRenderer ()
| Default Constructor.
virtual | ~GLRenderer ()
| Destructor.
virtual void | clear ()
| Explicit default initialization.
void | dump (std::ostream &s, Size depth) const
Name | getName (const GeometricObject &object)
GeometricObject * | getObject (GLRenderer::Name name) const
virtual bool | init (const Stage &stage, float width, float height)
| Initialise the renderer, e.g. the display lists.
virtual void | setLights (bool reset_all=false)
| Set the light sources according to the stage.
virtual void | setSmoothLines (bool smooth_lines)
virtual bool | getSmoothLines ()
virtual void | pickObjects (Position x1, Position y1, Position x2, Position y2, std::list< GeometricObject * > &objects)
void | pickObjects1 (Position x1, Position y1, Position x2, Position y2)
void | pickObjects2 (std::list< GeometricObject * > &objects)
void | setFogIntensity (float intensity)
void | enterPickingMode ()
void | exitPickingMode ()
void | setSize (float width, float height)
| Set the size of the display.
float | getXScale () const
float | getYScale () const
virtual void | updateBackgroundColor ()
| Update the background color from the stage.
void | initTransparent ()
void | initSolid ()
void | initAlwaysFront ()
void | setAntialiasing (bool state)
| Enable or disable antialiasing.
void | removeRepresentation (const Representation &rep)
| Remove all VertexBuffer and DisplayLists for the given Representation.
void | bufferRepresentation (const Representation &rep)
| Buffer the visualisation for the given Representation into OpenGL VertexBuffer Objects and DisplayLists.
void | drawBuffered (const Representation &rep)
| Draw the visualisation of the given Representation from the VertexBuffers and a DisplayList.
bool | hasDisplayListFor (const Representation &rep) const
| Test if a Representation has a DisplayList.
RenderMode | getRenderMode () const
void | setRenderMode (RenderMode mode)
virtual void | renderToBuffer (RenderTarget *renderTarget, BufferMode)
virtual bool | render (const Representation &representation, bool for_display_list=false)
virtual void | bufferingDependentRender_ (const Representation &repr, BufferMode mode)
bool | isExtensionSupported (const String &extension) const
void | clearVertexBuffersFor (Representation &rep)
bool | vertexBuffersSupported () const
String | getVendor ()
String | getRenderer ()
String | getOpenGLVersion ()
vector< String > | getExtensions ()
bool | runningOnVirtualBox ()
bool | enableVertexBuffers (bool state)
bool | vertexBuffersEnabled () const
DrawingMode | getDrawingMode () const
void | initPerspective ()
void | setProjection ()
void | setColorRGBA_ (const ColorRGBA &color)
void | vertexVector3_ (const Vector3 &v)
void | updateCamera (const Camera *camera=0)
void | setupStereo (float eye_separation, float focal_length)
Position | createTextureFromGrid (const RegularData3D &grid, const ColorMap &map)
void | removeTextureFor_ (const RegularData3D &grid)
virtual void | getFrustum (float &near_f, float &far_f, float &left_f, float &right_f, float &top_f, float &bottom_f)
void | updateMaterialForRepresentation (Representation const *rep)
virtual bool | init (Scene &scene)
Public Member Functions inherited from BALL::VIEW::Renderer
| Renderer ()
| Renderer (const Renderer &renderer)
virtual | ~Renderer ()
virtual void | setupEnvironmentMap (const QImage &image)
| Setup an environment map.
virtual void | useContinuousLoop (bool use_loop)
bool | isContinuous ()
virtual bool | hasFPScounter ()
virtual double | getFPS ()
virtual bool | finish ()
virtual Vector3 | mapViewportTo3D (Position x, Position y)
virtual Vector2 | map3DToViewport (const Vector3 &vec)
virtual bool | renderOneRepresentation (const Representation &representation)
virtual const Stage & | getStage () const
virtual void | setStage (const Stage &stage)
bool | hasStage () const
| Test if a Stage was assigned to the Renderer.
virtual float | getWidth () const
virtual float | getHeight () const
virtual void | setPreviewMode (bool show_preview)
virtual void | showLightSources (bool show_light_sources)
virtual void | setStereoMode (StereoMode state)
virtual StereoMode | getStereoMode () const
virtual void | setStereoFrustumConversion (int width_factor, int height_factor)
bool | operator== (const Renderer &) const
virtual void | render_ (const GeometricObject *object)
| Wrapper for the renderering of special GeometricObjects.

## Protected Types

typedef HashMap< const GeometricObject *, Name > | NameHashMap
typedef HashMap< Name, const GeometricObject * > | GeometricObjectHashMap
typedef HashMap< const Representation *, GLDisplayList * > | DisplayListHashMap
typedef HashMap< const Representation *, vector< MeshBuffer * > > | MeshBufferHashMap

## Protected Member Functions

bool | mapViewplaneToScreen_ ()
void | renderRepresentation_ (const Representation &representation, bool for_display_list)
void | renderRepresentations_ (BufferMode mode)
virtual void | renderLabel_ (const Label &)
virtual void | renderLine_ (const Line &)
| Render a line.
virtual void | renderMultiLine_ (const MultiLine &line)
| Render an illuminated line.
virtual void | renderMesh_ (const Mesh &)
| Render a surface mesh.
virtual void | renderQuadMesh_ (const QuadMesh &)
| Render a quad mesh.
void | initDrawingMeshes_ ()
void | initDrawingOthers_ ()
virtual void | renderRuler ()
virtual void | renderPoint_ (const Point &)
| Render a single point.
virtual void | renderSimpleBox_ (const SimpleBox &)
| Render a simple box (parallel to the axes).
virtual void | renderBox_ (const Box &)
| Render a box.
virtual void | renderSphere_ (const Sphere &)
| Render a sphere.
virtual void | renderDisc_ (const Disc &)
| Render a disc.
virtual void | renderTube_ (const Tube &)
| Render a tube.
virtual void | renderTwoColoredLine_ (const TwoColoredLine &)
| Render a line with two colors.
virtual void | renderTwoColoredTube_ (const TwoColoredTube &)
| Render a tube with two colors.
virtual void | renderClippingPlane_ (const ClippingPlane &plane)
virtual void | renderGridVisualisation_ (const GridVisualisation &vol)
| Render a grid slice.
void | setColor4ub_ (const GeometricObject &object)
void | createSpheres_ ()
void | createTubes_ ()
void | createBoxes_ ()
void | createDottedSphere_ (int precision)
void | subdivideTriangle_ (Vector3 &v1, Vector3 &v2, Vector3 &v3, int precision)
void | createLineBox_ ()
void | createDotBox_ ()
void | createSolidBox_ ()
void | clearNames_ ()
void | normalVector3_ (const Vector3 &v)
void | translateVector3_ (const Vector3 &v)
void | texCoordVector3_ (const Vector3 &v)
void | scaleVector3_ (const Vector3 &v)
void | rotateVector3Angle_ (const Vector3 &v, Real angle)
void | scale_ (float f)
void | initGLU_ (DrawingMode mode)
void | setOrthographicZoom (float orthographic_zoom)
float | getOrthographicZoom (void)
void | generateIlluminationTexture_ (float ka, float kd, float kr, float shininess)
Position | getTextureIndex_ (Position x, Position y, Position z, Size width, Size height)
void | setupGridClipPlanes_ (const GridVisualisation &slice)
void | setMaterial_ (const Stage::Material &mat)

## Protected Attributes

DrawingMode | drawing_mode_
Index | drawing_precision_
float | near_
float | far_
float | left_
float | right_
float | top_
float | bottom_
float | x_scale_
float | y_scale_
GLDisplayList * | GL_spheres_list_
GLDisplayList * | GL_tubes_list_
GLDisplayList * | GL_boxes_list_
GLDisplayList * | sphere_list_
GLDisplayList | line_list_
GLuint | line_texture_bind_
GLubyte | line_tex_ [128][128][4]
GeometricObjectHashMap | name_to_object_
NameHashMap | object_to_name_
DisplayListHashMap | display_lists_
MeshBufferHashMap | rep_to_buffers_
Name | all_names_
GLuint | object_buffer_ [BALL_GLRENDERER_PICKING_NUMBER_OF_MAX_OBJECTS]
Vector3 | normal_vector_
RenderMode | render_mode_
bool | use_vertex_buffer_
bool | smooth_lines_
bool | picking_mode_
ModelType | model_type_
Position | display_lists_index_
bool | single_pick_
bool | drawed_other_object_
bool | drawed_mesh_
GLUquadricObj * | GLU_quadric_obj_
HashMap< const RegularData3D *, Position > | grid_to_texture_
GLuint | cel_texture_
float | orthographic_zoom_
Scene * | scene_
const Stage * | stage_
float | width_
float | height_
bool | show_preview_
float | volume_width_
bool | show_light_sources_
Camera | camera_
Vector3 | camera_offset_
bool | use_continuous_loop_
Size | stereo_frustum_conversion_width_
Size | stereo_frustum_conversion_height_
StereoMode | stereo_

## Friends

class | Scene

## Detailed Description

GLRenderer Renderer which provides hardware accelerated OPENGL rendering.

Definition at line 74 of file glRenderer.h.

## Member Typedef Documentation

## DisplayListHashMap

typedef HashMap<const Representation*, GLDisplayList*> BALL::VIEW::GLRenderer::DisplayListHashMap

protected

Definition at line 471 of file glRenderer.h.

## GeometricObjectHashMap

typedef HashMap<Name, const GeometricObject*> BALL::VIEW::GLRenderer::GeometricObjectHashMap

protected

Definition at line 470 of file glRenderer.h.

## MeshBufferHashMap

typedef HashMap<const Representation*, vector<MeshBuffer*> > BALL::VIEW::GLRenderer::MeshBufferHashMap

protected

Definition at line 472 of file glRenderer.h.

## Name

typedef unsigned int BALL::VIEW::GLRenderer::Name

Typedef for OPENGL names.

Definition at line 124 of file glRenderer.h.

## NameHashMap

typedef HashMap<const GeometricObject*, Name> BALL::VIEW::GLRenderer::NameHashMap

protected

Definition at line 469 of file glRenderer.h.

## Member Enumeration Documentation

## BufferMode

enum BALL::VIEW::GLRenderer::BufferMode

Enumerator
DIRECT_RENDERING | Render without display lists, directly to the Scene.
DISPLAY_LISTS_RENDERING | Render the contents of the display lists.
REBUILD_DISPLAY_LISTS | Rebuild the contents of the display lists and redraw them.

Definition at line 98 of file glRenderer.h.

## RenderMode

enum BALL::VIEW::GLRenderer::RenderMode

Enumerator
RENDER_MODE_UNDEFINED |
RENDER_MODE_SOLID |
RENDER_MODE_TRANSPARENT |
RENDER_MODE_ALWAYS_FRONT |

Definition at line 81 of file glRenderer.h.

## Constructor & Destructor Documentation

## GLRenderer()

BALL::VIEW::GLRenderer::GLRenderer | ( |  | ) |

Default Constructor.

## ~GLRenderer()

virtual BALL::VIEW::GLRenderer::~GLRenderer | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## bufferingDependentRender_()

virtual void BALL::VIEW::GLRenderer::bufferingDependentRender_ | ( | const Representation & | repr,
|  | BufferMode | mode )

virtual

## bufferRepresentation()

void BALL::VIEW::GLRenderer::bufferRepresentation | ( | const Representation & | rep | ) |

virtual

Buffer the visualisation for the given Representation into OpenGL VertexBuffer Objects and DisplayLists.

Reimplemented from BALL::VIEW::Renderer.

## clear()

virtual void BALL::VIEW::GLRenderer::clear | ( |  | ) |

virtual

Explicit default initialization.

Reimplemented from BALL::VIEW::Renderer.

## clearNames_()

void BALL::VIEW::GLRenderer::clearNames_ | ( |  | ) |

protected

## clearVertexBuffersFor()

void BALL::VIEW::GLRenderer::clearVertexBuffersFor | ( | Representation & | rep | ) |

## createBoxes_()

void BALL::VIEW::GLRenderer::createBoxes_ | ( |  | ) |

protected

## createDotBox_()

void BALL::VIEW::GLRenderer::createDotBox_ | ( |  | ) |

protected

## createDottedSphere_()

void BALL::VIEW::GLRenderer::createDottedSphere_ | ( | int | precision | ) |

protected

## createLineBox_()

void BALL::VIEW::GLRenderer::createLineBox_ | ( |  | ) |

protected

## createSolidBox_()

void BALL::VIEW::GLRenderer::createSolidBox_ | ( |  | ) |

protected

## createSpheres_()

void BALL::VIEW::GLRenderer::createSpheres_ | ( |  | ) |

protected

## createTextureFromGrid()

Position BALL::VIEW::GLRenderer::createTextureFromGrid | ( | const RegularData3D & | grid,
|  | const ColorMap & | map )

## createTubes_()

void BALL::VIEW::GLRenderer::createTubes_ | ( |  | ) |

protected

## drawBuffered()

void BALL::VIEW::GLRenderer::drawBuffered | ( | const Representation & | rep | ) |

Draw the visualisation of the given Representation from the VertexBuffers and a DisplayList.

## dump()

void BALL::VIEW::GLRenderer::dump | ( | std::ostream & | s,
|  | Size | depth ) const

## enableVertexBuffers()

bool BALL::VIEW::GLRenderer::enableVertexBuffers | ( | bool | state | ) |

## enterPickingMode()

void BALL::VIEW::GLRenderer::enterPickingMode | ( |  | ) |

## exitPickingMode()

void BALL::VIEW::GLRenderer::exitPickingMode | ( |  | ) |

## generateIlluminationTexture_()

void BALL::VIEW::GLRenderer::generateIlluminationTexture_ | ( | float | ka,
|  | float | kd,
|  | float | kr,
|  | float | shininess )

protected

## getDrawingMode()

DrawingMode BALL::VIEW::GLRenderer::getDrawingMode | ( |  | ) | const

## getExtensions()

vector< String > BALL::VIEW::GLRenderer::getExtensions | ( |  | ) |

## getFrustum()

virtual void BALL::VIEW::GLRenderer::getFrustum | ( | float & | near_f,
|  | float & | far_f,
|  | float & | left_f,
|  | float & | right_f,
|  | float & | top_f,
|  | float & | bottom_f )

virtual

Return the frustum used by this renderer.

Reimplemented from BALL::VIEW::Renderer.

## getName()

Name BALL::VIEW::GLRenderer::getName | ( | const GeometricObject & | object | ) |

inline

## getObject()

GeometricObject * BALL::VIEW::GLRenderer::getObject | ( | GLRenderer::Name | name | ) | const

## getOpenGLVersion()

String BALL::VIEW::GLRenderer::getOpenGLVersion | ( |  | ) |

## getOrthographicZoom()

float BALL::VIEW::GLRenderer::getOrthographicZoom | ( | void |  | ) |

protected

## getRenderer()

String BALL::VIEW::GLRenderer::getRenderer | ( |  | ) |

## getRenderMode()

RenderMode BALL::VIEW::GLRenderer::getRenderMode | ( |  | ) | const

## getSmoothLines()

virtual bool BALL::VIEW::GLRenderer::getSmoothLines | ( |  | ) |

virtual

## getTextureIndex_()

Position BALL::VIEW::GLRenderer::getTextureIndex_ | ( | Position | x,
|  | Position | y,
|  | Position | z,
|  | Size | width,
|  | Size | height )

inline protected

## getVendor()

String BALL::VIEW::GLRenderer::getVendor | ( |  | ) |

## getXScale()

float BALL::VIEW::GLRenderer::getXScale | ( |  | ) | const

## getYScale()

float BALL::VIEW::GLRenderer::getYScale | ( |  | ) | const

## hasDisplayListFor()

bool BALL::VIEW::GLRenderer::hasDisplayListFor | ( | const Representation & | rep | ) | const

Test if a Representation has a DisplayList.

## init() [1/2]

virtual bool BALL::VIEW::GLRenderer::init | ( | const Stage & | stage,
|  | float | width,
|  | float | height )

virtual

Initialise the renderer, e.g. the display lists.

Reimplemented from BALL::VIEW::Renderer.

## init() [2/2]

virtual bool BALL::VIEW::Renderer::init | ( | Scene & | scene | ) |

virtual

Initialization routines. This method is called by Scene::initializeGL.

Reimplemented from BALL::VIEW::Renderer.

## initAlwaysFront()

void BALL::VIEW::GLRenderer::initAlwaysFront | ( |  | ) |

## initDrawingMeshes_()

void BALL::VIEW::GLRenderer::initDrawingMeshes_ | ( |  | ) |

protected

## initDrawingOthers_()

void BALL::VIEW::GLRenderer::initDrawingOthers_ | ( |  | ) |

protected

## initGLU_()

void BALL::VIEW::GLRenderer::initGLU_ | ( | DrawingMode | mode | ) |

protected

## initPerspective()

void BALL::VIEW::GLRenderer::initPerspective | ( |  | ) |

## initSolid()

void BALL::VIEW::GLRenderer::initSolid | ( |  | ) |

## initTransparent()

void BALL::VIEW::GLRenderer::initTransparent | ( |  | ) |

## isExtensionSupported()

bool BALL::VIEW::GLRenderer::isExtensionSupported | ( | const String & | extension | ) | const

Test if a given opengl extension is supported by the current driver. Call this only after Scene::initializeGL();

## mapViewplaneToScreen_()

bool BALL::VIEW::GLRenderer::mapViewplaneToScreen_ | ( |  | ) |

protected

Maps the current viewplane to screen coordinates. Returns false if the projection matrix is not correctly initialized.

## normalVector3_()

void BALL::VIEW::GLRenderer::normalVector3_ | ( | const Vector3 & | v | ) |

protected

## pickObjects()

virtual void BALL::VIEW::GLRenderer::pickObjects | ( | Position | x1,
|  | Position | y1,
|  | Position | x2,
|  | Position | y2,
|  | std::list< GeometricObject * > & | objects )

virtual

Pick all objects in the given screen rectangle.

Reimplemented from BALL::VIEW::Renderer.

## pickObjects1()

void BALL::VIEW::GLRenderer::pickObjects1 | ( | Position | x1,
|  | Position | y1,
|  | Position | x2,
|  | Position | y2 )

Pick geometric objects

Parameters

  x1,y1,x2,y2 | the rectangle of the selection

## pickObjects2()

void BALL::VIEW::GLRenderer::pickObjects2 | ( | std::list< GeometricObject * > & | objects | ) |

Pick geometric objects method2. Call this method after pickObjects1 and rendering the representations.

Parameters

  objects | returns the picked objects

## removeRepresentation()

void BALL::VIEW::GLRenderer::removeRepresentation | ( | const Representation & | rep | ) |

virtual

Remove all VertexBuffer and DisplayLists for the given Representation.

Reimplemented from BALL::VIEW::Renderer.

## removeTextureFor_()

void BALL::VIEW::GLRenderer::removeTextureFor_ | ( | const RegularData3D & | grid | ) |

## render()

virtual bool BALL::VIEW::GLRenderer::render | ( | const Representation & | representation,
|  | bool | for_display_list = false )

virtual

## renderBox_()

virtual void BALL::VIEW::GLRenderer::renderBox_ | ( | const Box & |  | ) |

protected virtual

Render a box.

Reimplemented from BALL::VIEW::Renderer.

## renderClippingPlane_()

virtual void BALL::VIEW::GLRenderer::renderClippingPlane_ | ( | const ClippingPlane & | plane | ) |

protected virtual

Reimplemented from BALL::VIEW::Renderer.

## renderDisc_()

virtual void BALL::VIEW::GLRenderer::renderDisc_ | ( | const Disc & |  | ) |

protected virtual

Render a disc.

Reimplemented from BALL::VIEW::Renderer.

## renderGridVisualisation_()

virtual void BALL::VIEW::GLRenderer::renderGridVisualisation_ | ( | const GridVisualisation & | vol | ) |

protected virtual

Render a grid slice.

Reimplemented from BALL::VIEW::Renderer.

## renderLabel_()

virtual void BALL::VIEW::GLRenderer::renderLabel_ | ( | const Label & |  | ) |

protected virtual

Reimplemented from BALL::VIEW::Renderer.

## renderLine_()

virtual void BALL::VIEW::GLRenderer::renderLine_ | ( | const Line & |  | ) |

protected virtual

Render a line.

Reimplemented from BALL::VIEW::Renderer.

## renderMesh_()

virtual void BALL::VIEW::GLRenderer::renderMesh_ | ( | const Mesh & |  | ) |

protected virtual

Render a surface mesh.

Reimplemented from BALL::VIEW::Renderer.

## renderMultiLine_()

virtual void BALL::VIEW::GLRenderer::renderMultiLine_ | ( | const MultiLine & | line | ) |

protected virtual

Render an illuminated line.

Reimplemented from BALL::VIEW::Renderer.

## renderPoint_()

virtual void BALL::VIEW::GLRenderer::renderPoint_ | ( | const Point & |  | ) |

protected virtual

Render a single point.

Reimplemented from BALL::VIEW::Renderer.

## renderQuadMesh_()

virtual void BALL::VIEW::GLRenderer::renderQuadMesh_ | ( | const QuadMesh & |  | ) |

protected virtual

Render a quad mesh.

Reimplemented from BALL::VIEW::Renderer.

## renderRepresentation_()

void BALL::VIEW::GLRenderer::renderRepresentation_ | ( | const Representation & | representation,
|  | bool | for_display_list )

protected

## renderRepresentations_()

void BALL::VIEW::GLRenderer::renderRepresentations_ | ( | BufferMode | mode | ) |

protected

## renderRuler()

virtual void BALL::VIEW::GLRenderer::renderRuler | ( |  | ) |

protected virtual

Render a ruler.

If supported by the renderer implementation, this function will produce a simple ruler that is rendered together with the other representations. The main use of this function is in the edit mode, where it can help to straighten-up structures and to correctly estimate angles and distances.

Reimplemented from BALL::VIEW::Renderer.

## renderSimpleBox_()

virtual void BALL::VIEW::GLRenderer::renderSimpleBox_ | ( | const SimpleBox & |  | ) |

protected virtual

Render a simple box (parallel to the axes).

Reimplemented from BALL::VIEW::Renderer.

## renderSphere_()

virtual void BALL::VIEW::GLRenderer::renderSphere_ | ( | const Sphere & |  | ) |

protected virtual

Render a sphere.

Reimplemented from BALL::VIEW::Renderer.

## renderToBuffer()

virtual void BALL::VIEW::GLRenderer::renderToBuffer | ( | RenderTarget * | renderTarget,
|  | BufferMode | )

virtual

This function renders into the buffer of the RenderTarget which has to be made current before this function is called. Buffers are not automatically swapped afterwards!

## renderTube_()

virtual void BALL::VIEW::GLRenderer::renderTube_ | ( | const Tube & |  | ) |

protected virtual

Render a tube.

Reimplemented from BALL::VIEW::Renderer.

## renderTwoColoredLine_()

virtual void BALL::VIEW::GLRenderer::renderTwoColoredLine_ | ( | const TwoColoredLine & |  | ) |

protected virtual

Render a line with two colors.

Reimplemented from BALL::VIEW::Renderer.

## renderTwoColoredTube_()

virtual void BALL::VIEW::GLRenderer::renderTwoColoredTube_ | ( | const TwoColoredTube & |  | ) |

protected virtual

Render a tube with two colors.

Reimplemented from BALL::VIEW::Renderer.

## rotateVector3Angle_()

void BALL::VIEW::GLRenderer::rotateVector3Angle_ | ( | const Vector3 & | v,
|  | Real | angle )

protected

## runningOnVirtualBox()

bool BALL::VIEW::GLRenderer::runningOnVirtualBox | ( |  | ) |

## scale_()

void BALL::VIEW::GLRenderer::scale_ | ( | float | f | ) |

protected

## scaleVector3_()

void BALL::VIEW::GLRenderer::scaleVector3_ | ( | const Vector3 & | v | ) |

protected

## setAntialiasing()

void BALL::VIEW::GLRenderer::setAntialiasing | ( | bool | state | ) |

Enable or disable antialiasing.

## setColor4ub_()

void BALL::VIEW::GLRenderer::setColor4ub_ | ( | const GeometricObject & | object | ) |

protected

## setColorRGBA_()

void BALL::VIEW::GLRenderer::setColorRGBA_ | ( | const ColorRGBA & | color | ) |

## setFogIntensity()

void BALL::VIEW::GLRenderer::setFogIntensity | ( | float | intensity | ) |

Set the GL_FOG intensity

## setLights()

virtual void BALL::VIEW::GLRenderer::setLights | ( | bool | reset_all = false | ) |

virtual

Set the light sources according to the stage.

Reimplemented from BALL::VIEW::Renderer.

## setMaterial_()

void BALL::VIEW::GLRenderer::setMaterial_ | ( | const Stage::Material & | mat | ) |

protected

## setOrthographicZoom()

void BALL::VIEW::GLRenderer::setOrthographicZoom | ( | float | orthographic_zoom | ) |

protected

## setProjection()

void BALL::VIEW::GLRenderer::setProjection | ( |  | ) |

## setRenderMode()

void BALL::VIEW::GLRenderer::setRenderMode | ( | RenderMode | mode | ) |

inline

Definition at line 223 of file glRenderer.h.

## setSize()

void BALL::VIEW::GLRenderer::setSize | ( | float | width,
|  | float | height )

virtual

Set the size of the display.

Reimplemented from BALL::VIEW::Renderer.

## setSmoothLines()

virtual void BALL::VIEW::GLRenderer::setSmoothLines | ( | bool | smooth_lines | ) |

virtual

Should the lines in the line representation and the wireframe models be smoothed?

## setupGridClipPlanes_()

void BALL::VIEW::GLRenderer::setupGridClipPlanes_ | ( | const GridVisualisation & | slice | ) |

protected

## setupStereo()

void BALL::VIEW::GLRenderer::setupStereo | ( | float | eye_separation,
|  | float | focal_length )

virtual

Sets this renderer as a part of a stereo setup.

eye_separation denotes the distance along the right vector used by this "eye".

Reimplemented from BALL::VIEW::Renderer.

## subdivideTriangle_()

void BALL::VIEW::GLRenderer::subdivideTriangle_ | ( | Vector3 & | v1,
|  | Vector3 & | v2,
|  | Vector3 & | v3,
|  | int | precision )

protected

## texCoordVector3_()

void BALL::VIEW::GLRenderer::texCoordVector3_ | ( | const Vector3 & | v | ) |

inline protected

Definition at line 406 of file glRenderer.h.

## translateVector3_()

void BALL::VIEW::GLRenderer::translateVector3_ | ( | const Vector3 & | v | ) |

protected

## updateBackgroundColor()

virtual void BALL::VIEW::GLRenderer::updateBackgroundColor | ( |  | ) |

virtual

Update the background color from the stage.

Reimplemented from BALL::VIEW::Renderer.

## updateCamera()

void BALL::VIEW::GLRenderer::updateCamera | ( | const Camera * | camera = 0 | ) |

virtual

Update the camera position either from a given Camera, or from the default Stage.

Reimplemented from BALL::VIEW::Renderer.

## updateMaterialForRepresentation()

void BALL::VIEW::GLRenderer::updateMaterialForRepresentation | ( | Representation const * |  | ) |

inline virtual

Updates the material for the current representation

Reimplemented from BALL::VIEW::Renderer.

Definition at line 294 of file glRenderer.h.

## vertexBuffersEnabled()

bool BALL::VIEW::GLRenderer::vertexBuffersEnabled | ( |  | ) | const

## vertexBuffersSupported()

bool BALL::VIEW::GLRenderer::vertexBuffersSupported | ( |  | ) | const

## vertexVector3_()

void BALL::VIEW::GLRenderer::vertexVector3_ | ( | const Vector3 & | v | ) |

## Friends And Related Symbol Documentation

## Scene

friend class Scene

friend

Definition at line 77 of file glRenderer.h.

## Member Data Documentation

## all_names_

Name BALL::VIEW::GLRenderer::all_names_

protected

Definition at line 478 of file glRenderer.h.

## bottom_

float BALL::VIEW::GLRenderer::bottom_

protected

Definition at line 452 of file glRenderer.h.

## cel_texture_

GLuint BALL::VIEW::GLRenderer::cel_texture_

protected

Definition at line 494 of file glRenderer.h.

## display_lists_

DisplayListHashMap BALL::VIEW::GLRenderer::display_lists_

protected

Definition at line 476 of file glRenderer.h.

## display_lists_index_

Position BALL::VIEW::GLRenderer::display_lists_index_

protected

Definition at line 488 of file glRenderer.h.

## drawed_mesh_

bool BALL::VIEW::GLRenderer::drawed_mesh_

protected

Definition at line 491 of file glRenderer.h.

## drawed_other_object_

bool BALL::VIEW::GLRenderer::drawed_other_object_

protected

Definition at line 490 of file glRenderer.h.

## drawing_mode_

DrawingMode BALL::VIEW::GLRenderer::drawing_mode_

protected

Definition at line 436 of file glRenderer.h.

## drawing_precision_

Index BALL::VIEW::GLRenderer::drawing_precision_

protected

Definition at line 439 of file glRenderer.h.

## far_

float BALL::VIEW::GLRenderer::far_

protected

Definition at line 444 of file glRenderer.h.

## GL_boxes_list_

GLDisplayList* BALL::VIEW::GLRenderer::GL_boxes_list_

protected

Definition at line 462 of file glRenderer.h.

## GL_spheres_list_

GLDisplayList* BALL::VIEW::GLRenderer::GL_spheres_list_

protected

Definition at line 460 of file glRenderer.h.

## GL_tubes_list_

GLDisplayList* BALL::VIEW::GLRenderer::GL_tubes_list_

protected

Definition at line 461 of file glRenderer.h.

## GLU_quadric_obj_

GLUquadricObj* BALL::VIEW::GLRenderer::GLU_quadric_obj_

protected

Definition at line 492 of file glRenderer.h.

## grid_to_texture_

HashMap<const RegularData3D*, Position> BALL::VIEW::GLRenderer::grid_to_texture_

protected

Definition at line 493 of file glRenderer.h.

## left_

float BALL::VIEW::GLRenderer::left_

protected

Definition at line 446 of file glRenderer.h.

## line_list_

GLDisplayList BALL::VIEW::GLRenderer::line_list_

protected

Definition at line 464 of file glRenderer.h.

## line_tex_

GLubyte BALL::VIEW::GLRenderer::line_tex_[128][128][4]

protected

Definition at line 466 of file glRenderer.h.

## line_texture_bind_

GLuint BALL::VIEW::GLRenderer::line_texture_bind_

protected

Definition at line 465 of file glRenderer.h.

## model_type_

ModelType BALL::VIEW::GLRenderer::model_type_

protected

Definition at line 487 of file glRenderer.h.

## name_to_object_

GeometricObjectHashMap BALL::VIEW::GLRenderer::name_to_object_

protected

Definition at line 474 of file glRenderer.h.

## near_

float BALL::VIEW::GLRenderer::near_

protected

Definition at line 442 of file glRenderer.h.

## normal_vector_

Vector3 BALL::VIEW::GLRenderer::normal_vector_

protected

Definition at line 480 of file glRenderer.h.

## object_buffer_

GLuint BALL::VIEW::GLRenderer::object_buffer_[BALL_GLRENDERER_PICKING_NUMBER_OF_MAX_OBJECTS]

protected

Definition at line 479 of file glRenderer.h.

## object_to_name_

NameHashMap BALL::VIEW::GLRenderer::object_to_name_

protected

Definition at line 475 of file glRenderer.h.

## orthographic_zoom_

float BALL::VIEW::GLRenderer::orthographic_zoom_

protected

Definition at line 496 of file glRenderer.h.

## picking_mode_

bool BALL::VIEW::GLRenderer::picking_mode_

protected

Definition at line 486 of file glRenderer.h.

## render_mode_

RenderMode BALL::VIEW::GLRenderer::render_mode_

protected

Definition at line 482 of file glRenderer.h.

## rep_to_buffers_

MeshBufferHashMap BALL::VIEW::GLRenderer::rep_to_buffers_

protected

Definition at line 477 of file glRenderer.h.

## right_

float BALL::VIEW::GLRenderer::right_

protected

Definition at line 448 of file glRenderer.h.

## single_pick_

bool BALL::VIEW::GLRenderer::single_pick_

protected

Definition at line 489 of file glRenderer.h.

## smooth_lines_

bool BALL::VIEW::GLRenderer::smooth_lines_

protected

Definition at line 485 of file glRenderer.h.

## sphere_list_

GLDisplayList* BALL::VIEW::GLRenderer::sphere_list_

protected

Definition at line 463 of file glRenderer.h.

## top_

float BALL::VIEW::GLRenderer::top_

protected

Definition at line 450 of file glRenderer.h.

## use_vertex_buffer_

bool BALL::VIEW::GLRenderer::use_vertex_buffer_

protected

Definition at line 484 of file glRenderer.h.

## x_scale_

float BALL::VIEW::GLRenderer::x_scale_

protected

Definition at line 455 of file glRenderer.h.

## y_scale_

float BALL::VIEW::GLRenderer::y_scale_

protected

Definition at line 458 of file glRenderer.h.